<template>
  <div
    class="do-part-name-input multiselect no-checkbox"
    :class="addClasses"
    v-click-outside="onBlur">
    <div
      v-if="loading"
      class="multiselect__spinner"/>
    <div
      v-else-if="query.length"
      @click="select('')"
      class="multiselect__clear">
      <img
        svg-inline
        src="~/assets/svg/redesign/cross.svg">
    </div>
    <div class="multiselect__tags">
      <input
        type="text"
        v-model="query"
        :disabled="disabled"
        @focus="open"
        @keydown.down="onArrowDown"
        @keydown.up="onArrowUp"
        @keydown.enter="onEnter"
        class="multiselect__input"
        :placeholder="placeholder">
    </div>
    <div
      v-show="opened && !loading && (options.length || queryValid)"
      class="multiselect__content-wrapper">
      <ul class="multiselect__content">
        <template v-if="options.length">
          <li
            class="multiselect__element"
            v-for="(option, i) of options"
            :key="i"
            @mousedown="select(option)">
            <span
              class="multiselect__option"
              :class="{ active: i === activeOption }">{{ option }}</span>
          </li>
        </template>
        <template v-else-if="queryValid">
          <li class="multiselect__element">
            <span class="multiselect__option notfound">
              <p>Найдено в заголовках объявлений — 0
                <span class="desktopshow">Поискать в тексте объявлений — нажмите enter</span>
              </p>
            </span>
          </li>
        </template>
        <template v-else>
          <li class="multiselect__element">
            <span class="multiselect__option notfound">Начните вводить название запчасти </span>
          </li>
        </template>
      </ul>
    </div>
  </div>
</template>

<script>
// TODO: сделать абстракцию для этого инпута и аналогичного из винзапроса

import { debounce } from 'lodash-es';

export default {
  name: 'DoPartNameInput',
  props: {
    value: {
      type: String,
      default: '',
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    placeholder: {
      type: String,
      default: '',
    },
    classes: {
      type: Array,
      default() { return []; },
    },
  },
  data() {
    return {
      opened: false,
      loading: false,
      query: this.value ? String(this.value) : '',
      options: [],
      activeOption: -1,
    };
  },
  computed: {
    queryValid() {
      return this.query && this.query.length >= 3;
    },
    addClasses() {
      const classes = [];
      this.disabled && classes.push('multiselect--disabled');
      this.opened && classes.push('multiselect--active');
      classes.push(...this.classes);
      return classes;
    },
  },
  watch: {
    query() {
      this.onQueryChangeDebounced();
    },
    value(newValue) {
      if (newValue !== this.query) {
        this.query = String(newValue || '');
      }
    },
  },
  created() {
    this.onQueryChangeDebounced = debounce(this.onQueryChange, 200);
    if (this.query) {
      this.onQueryChange();
    }
  },
  methods: {
    open() {
      this.opened = true;
      this.activeOption = -1;
    },
    close() {
      this.opened = false;
    },
    select(option) {
      this.$emit('input', option);
      this.close();
    },
    onBlur() {
      if (!this.opened) {
        return false;
      }
      if (this.query !== (this.value === null ? '' : this.value)) {
        this.select(this.query);
      }
      this.close();
      return true;
    },
    async onQueryChange() {
      if (!this.queryValid) {
        this.options = [];
        return false;
      }
      try {
        this.loading = true;
        const { data } = await this.$axios.$get('/_main/contractParts/getPartNameSuggestions', {
          params: { text: this.query },
        });
        this.options = data || [];
        this.activeOption = -1;
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
      return true;
    },
    onArrowDown(event) {
      if (this.activeOption < this.options.length - 1) {
        this.activeOption = this.activeOption + 1;
      } else {
        this.activeOption = 0;
      }
      event.preventDefault();
    },
    onArrowUp(event) {
      if (this.activeOption > 0) {
        this.activeOption = this.activeOption - 1;
      } else {
        this.activeOption = this.options.length - 1;
      }
      event.preventDefault();
    },
    onEnter(event) {
      if (this.options[this.activeOption]) {
        this.select(this.options[this.activeOption]);
      } else if (this.activeOption < 0) {
        this.select(this.query);
      }
      // this.close();
      this.activeOption = -1;
      event.target.blur();
      event.preventDefault();
    },
  },
};
</script>

<style lang="postcss">
  @import '~/assets/css/components/forms/select.css';
  .do-part-name-input {
    .multiselect__option:not(.notfound).active,
    .multiselect__option:not(.notfound):hover {
      background: #dee7ed;
    }
    .multiselect__select {
      display: none !important;
    }
    .multiselect__input {
      width: 100%;
    }
    .multiselect__option {
      max-height: 3rem;
    }
    p {
      white-space: pre-line;
      font-size: 12px;
      font-weight: bold !important;
      color: #7e7e7e !important;
      margin: 0;
    }
  }
</style>
